; fast Rx routine for BCR port
; TTL RS-232 8N1 57600 baud
; direct connection, no filtering
; S. Adolph 

; receive inverted TTL
; start = 1 (zero)
; data is inverted
; stop = 0 (one)

	.org	60000d

start:				
	di			; initialize interrupt
	
 	lxi	h,0F5F9H
 	mvi	m, 0C3h 	; jmp
 	inx 	h
	lxi	b, rx_int
	mov	m, c
 	inx	h
 	mov	m, b		; jump to RX_int
 	
 	xra	a
 	sta	status		; clear status
 	
get_char:	
	di
 	mvi	a,00011110b	; reset timer, enable mask, enable 5.5
 	sim

	ei			; ready for data

; Rx monitor
; status bit at status:  1 = byte ready, 0 = no byte
;-------------------------	

rx_wait:
 	lda	status		; wait here for inbound character
 	ora	a
 	jz 	rx_wait
;-------------------------

; character received	
	di
	lda	byte
	rst	4		; print received character
	
 	xra	a
 	sta	status		; clear status

	jmp	get_char
	
status:	.db	00
byte:	.db	00


	
; 42.65 clock cycles is ideal for 57600		

rx_int:
		; an interrupt as occurred - data to be read
		; ignore start bit

	mvi	b,08d
 	mvi	c,00d		; preload
rx_loop:
	in	0B3H		; 10+7+4+4+4+4+10 = 43
	ani	00001000b	; get bit
	ora	c
	rrc
	mov	c,a
	dcr	b
	jnz 	rx_loop
	
	rrc
	rrc
	rrc
	
	cma
	sta	byte
	
	mvi	a,01
	sta	status

	ret
	
	
	.end